package Vehicles;

import java.awt.*;

/**
 * @author Nick
 */

public class Automobile implements Runnable {
    boolean useAutoLang = true;

    // 
    final static int AUTOMOBILE_STATE_RUN = 0;
    final static int AUTOMOBILE_STATE_WAIT_CAR = 1;
    final static int AUTOMOBILE_STATE_NEAR_JUNC = 2;
    final static int AUTOMOBILE_STATE_WAIT_CAR_NEAR_JUNC = 3;
    final static int AUTOMOBILE_STATE_WAIT_ON_JANC = 4;
    final static int AUTOMOBILE_STATE_TURN_LEFT = 5;
    final static int AUTOMOBILE_STATE_TURN_RIGHT = 6;
    final static int AUTOMOBILE_STATE_TURN_THROUGH = 7;

    // 
    final static int EVENT_CLOCK = 0;

    // 
    final static int DIRECTION_N = 0;
    final static int DIRECTION_E = 1;
    final static int DIRECTION_S = 2;
    final static int DIRECTION_W = 3;

    final static int DIRECTION_THROUGH = 0;
    final static int DIRECTION_RIGHT = 1;
    final static int DIRECTION_LEFT = 2;

    int y0;

    int automobileModel;

    boolean lights;

    int velociti;

    int startJunc;
    int endJunc;

    int oldDirection;

    int currentJunc;
    int turnDirection;
    int turnPosition;

    int distance;

    boolean stop;

    Point point = new Point();

    Junction[] juncs;
    Automobile[] cars;

    AutomobileAutomata auto = new AutomobileAutomata();

    AutomobileAutomataByHand autoByHand = new AutomobileAutomataByHand();

    private Thread thread = null;

    Automobile() {
        auto.a = this;
        autoByHand.a = this;

        auto.setState(auto.myState.s0);
    }

    void Start() {
        if (thread == null) {
            stop = false;

            thread = new Thread(this);

            thread.start();
        }
    }

    void Stop() {
        stop = true;
        thread = null;
    }

    boolean x0() //   
    {
        boolean i = IsCarNear();
        return i;
    }

    boolean x1() //  
    {
        boolean i = IsJunctionNear();
        return i;
    }

    boolean x2() //  ( )
    {
        boolean i = IsJunction();
        return i;
    }

    int x3() //  
    {
        int i = turnDirection;
        return i;
    }

    boolean x4() //  
    {
        boolean i = IsJuncFree();
        return i;
    }

    boolean x5() //   
    {
        boolean i = IsGreenLight();
        return i;
    }

    boolean x6() //   
    {
        boolean i = true;

        if (y0 == AUTOMOBILE_STATE_TURN_THROUGH)
            i = (turnPosition > 10);
        if (y0 == AUTOMOBILE_STATE_TURN_LEFT)
            i = (turnPosition > 10);
        if (y0 == AUTOMOBILE_STATE_TURN_RIGHT)
            i = (turnPosition > 6);

        return i;
    }

    void z0() //  () 
    {
        lights = !lights;
    }

    void z1() //  dx
    {
        Run();
    }

    void z2() //   dx
    {
        turnPosition++;
    }

    void z3() //   
    {
        turnDirection = GenerateTurnDirection();
    }

    void z4() //  
    {
        currentJunc = endJunc;

        oldDirection = GetDirection();

        if (turnDirection == DIRECTION_THROUGH)
            juncs[currentJunc].carsRunThrough[GetDirection()]++;
        if (turnDirection == DIRECTION_RIGHT)
            juncs[currentJunc].carsTurnRight[GetDirection()]++;
        if (turnDirection == DIRECTION_LEFT)
            juncs[currentJunc].carsTurnLeft[GetDirection()]++;
    }

    void z5() //  
    {
        turnPosition = 0;

        if (turnDirection == DIRECTION_THROUGH)
            y0 = AUTOMOBILE_STATE_TURN_THROUGH;
        if (turnDirection == DIRECTION_RIGHT)
            y0 = AUTOMOBILE_STATE_TURN_RIGHT;
        if (turnDirection == DIRECTION_LEFT)
            y0 = AUTOMOBILE_STATE_TURN_LEFT;

        SetDirection(turnDirection);
    }

    void z6() //  
    {
        if (turnDirection == DIRECTION_THROUGH)
            juncs[currentJunc].carsRunThrough[oldDirection]--;
        if (turnDirection == DIRECTION_RIGHT)
            juncs[currentJunc].carsTurnRight[oldDirection]--;
        if (turnDirection == DIRECTION_LEFT)
            juncs[currentJunc].carsTurnLeft[oldDirection]--;
    }

///////////////////////////////////////////////////////////////////////////////
//
//
//

    void Run() {
        distance += velociti;
    }

    int GetDirection() {
        if ((juncs[endJunc].x - juncs[startJunc].x) >= 0 && (juncs[endJunc].y - juncs[startJunc].y) >= 0) {
            return DIRECTION_E;
        }
        if ((juncs[endJunc].x - juncs[startJunc].x) >= 0 && (juncs[endJunc].y - juncs[startJunc].y) < 0) {
            return DIRECTION_N;
        }
        if ((juncs[endJunc].x - juncs[startJunc].x) < 0 && (juncs[endJunc].y - juncs[startJunc].y) >= 0) {
            return DIRECTION_S;
        }
        if ((juncs[endJunc].x - juncs[startJunc].x) < 0 && (juncs[endJunc].y - juncs[startJunc].y) < 0) {
            return DIRECTION_W;
        }

        return 0;
    }


    int GetDirection(int sj, int ej) {
        if ((juncs[ej].x - juncs[sj].x) >= 0 && (juncs[ej].y - juncs[sj].y) >= 0) {
            return DIRECTION_E;
        }
        if ((juncs[ej].x - juncs[sj].x) >= 0 && (juncs[ej].y - juncs[sj].y) < 0) {
            return DIRECTION_N;
        }
        if ((juncs[ej].x - juncs[sj].x) < 0 && (juncs[ej].y - juncs[sj].y) >= 0) {
            return DIRECTION_S;
        }
        if ((juncs[ej].x - juncs[sj].x) < 0 && (juncs[ej].y - juncs[sj].y) < 0) {
            return DIRECTION_W;
        }

        return 0;
    }

    int GenerateTurnDirection() {
        while (true) {
            int random = (int) (Math.random() * 3.5);

            int oldEndJunc = endJunc;
            int oldStartJunc = startJunc;

            if ((juncs[oldEndJunc].neighbours[random] != -1) && (juncs[oldEndJunc].neighbours[random] != oldStartJunc)) {
                int oldDirection = GetDirection();
                int newDirection = GetDirection(endJunc, juncs[oldEndJunc].neighbours[random]);

                if (oldDirection == DIRECTION_N) {
                    if (newDirection == DIRECTION_N)
                        return DIRECTION_THROUGH;
                    if (newDirection == DIRECTION_E)
                        return DIRECTION_RIGHT;
                    if (newDirection == DIRECTION_S)
                        return -1;
                    if (newDirection == DIRECTION_W)
                        return DIRECTION_LEFT;
                }
                if (oldDirection == DIRECTION_E) {
                    if (newDirection == DIRECTION_N)
                        return DIRECTION_LEFT;
                    if (newDirection == DIRECTION_E)
                        return DIRECTION_THROUGH;
                    if (newDirection == DIRECTION_S)
                        return DIRECTION_RIGHT;
                    if (newDirection == DIRECTION_W)
                        return -1;
                }
                if (oldDirection == DIRECTION_S) {
                    if (newDirection == DIRECTION_N)
                        return -1;
                    if (newDirection == DIRECTION_E)
                        return DIRECTION_LEFT;
                    if (newDirection == DIRECTION_S)
                        return DIRECTION_THROUGH;
                    if (newDirection == DIRECTION_W)
                        return DIRECTION_RIGHT;
                }
                if (oldDirection == DIRECTION_W) {
                    if (newDirection == DIRECTION_N)
                        return DIRECTION_RIGHT;
                    if (newDirection == DIRECTION_E)
                        return -1;
                    if (newDirection == DIRECTION_S)
                        return DIRECTION_LEFT;
                    if (newDirection == DIRECTION_W)
                        return DIRECTION_THROUGH;
                }

                break;
            }
        }

        return DIRECTION_THROUGH;
    }

    void SetDirection(int td) {
        int direction = GetDirection();
        int newDirection = DIRECTION_N;

        if (direction == DIRECTION_N) {
            if (td == DIRECTION_THROUGH)
                newDirection = DIRECTION_N;
            if (td == DIRECTION_RIGHT)
                newDirection = DIRECTION_E;
            if (td == DIRECTION_LEFT)
                newDirection = DIRECTION_W;
        }
        if (direction == DIRECTION_E) {
            if (td == DIRECTION_THROUGH)
                newDirection = DIRECTION_E;
            if (td == DIRECTION_RIGHT)
                newDirection = DIRECTION_S;
            if (td == DIRECTION_LEFT)
                newDirection = DIRECTION_N;
        }
        if (direction == DIRECTION_S) {
            if (td == DIRECTION_THROUGH)
                newDirection = DIRECTION_S;
            if (td == DIRECTION_RIGHT)
                newDirection = DIRECTION_W;
            if (td == DIRECTION_LEFT)
                newDirection = DIRECTION_E;
        }
        if (direction == DIRECTION_W) {
            if (td == DIRECTION_THROUGH)
                newDirection = DIRECTION_W;
            if (td == DIRECTION_RIGHT)
                newDirection = DIRECTION_N;
            if (td == DIRECTION_LEFT)
                newDirection = DIRECTION_S;
        }

        distance = 37;

        startJunc = endJunc;
        endJunc = juncs[endJunc].neighbours[newDirection];
    }

    int GetNextJunc(int td) {
        int direction = GetDirection();
        int newDirection = DIRECTION_N;

        if (direction == DIRECTION_N) {
            if (td == DIRECTION_THROUGH)
                newDirection = DIRECTION_N;
            if (td == DIRECTION_RIGHT)
                newDirection = DIRECTION_E;
            if (td == DIRECTION_LEFT)
                newDirection = DIRECTION_W;
        }
        if (direction == DIRECTION_E) {
            if (td == DIRECTION_THROUGH)
                newDirection = DIRECTION_E;
            if (td == DIRECTION_RIGHT)
                newDirection = DIRECTION_S;
            if (td == DIRECTION_LEFT)
                newDirection = DIRECTION_N;
        }
        if (direction == DIRECTION_S) {
            if (td == DIRECTION_THROUGH)
                newDirection = DIRECTION_S;
            if (td == DIRECTION_RIGHT)
                newDirection = DIRECTION_W;
            if (td == DIRECTION_LEFT)
                newDirection = DIRECTION_E;
        }
        if (direction == DIRECTION_W) {
            if (td == DIRECTION_THROUGH)
                newDirection = DIRECTION_W;
            if (td == DIRECTION_RIGHT)
                newDirection = DIRECTION_N;
            if (td == DIRECTION_LEFT)
                newDirection = DIRECTION_S;
        }

        return juncs[endJunc].neighbours[newDirection];
    }

    boolean IsCarNear() {
        for (Automobile car : cars) {
            if (car != this) {
                if ((car.startJunc == startJunc) && (car.endJunc == endJunc) &&
                        ((car.distance - distance) < 60) && ((car.distance - distance) > 0)) {
                    return true;
                }
            }
        }

        return false;
    }

    boolean IsJunction() {
        int distanceBetweenJuncs = (int) Math.sqrt(Math.pow(juncs[endJunc].y - juncs[startJunc].y, 2.0) + Math.pow(juncs[endJunc].x - juncs[startJunc].x, 2.0));

        if ((distanceBetweenJuncs - distance) <= 25) {
            distance = distanceBetweenJuncs - 25;
            return true;
        }

        return false;
    }

    boolean IsJunctionNear() {
        int distanceBetweenJuncs = (int) Math.sqrt(Math.pow(juncs[endJunc].y - juncs[startJunc].y, 2.0) + Math.pow(juncs[endJunc].x - juncs[startJunc].x, 2.0));

        return (distanceBetweenJuncs - distance) < 60;
    }

    int GetTurnFromDirection(int d) {
        return 0;
    }

    boolean IsGreenLight() {
        int direction = GetDirection();

        return ((juncs[currentJunc].type == Junction.JUNC_TYPE_NO_TL) ||
                ((juncs[currentJunc].y1 == Junction.JUNC_STATE_GREEN_NS) && (direction == DIRECTION_N || direction == DIRECTION_S)) ||
                ((juncs[currentJunc].y1 == Junction.JUNC_STATE_GREEN_EW) && (direction == DIRECTION_W || direction == DIRECTION_E)));
    }

    boolean IsJuncFree() {
        int direction = GetDirection();

        if (juncs[currentJunc].carsRunThrough[direction] +
                juncs[currentJunc].carsTurnLeft[direction] +
                juncs[currentJunc].carsTurnRight[direction] != 1)
            return false;

        for (Automobile car : cars) {
            if (car != this) {
                if ((car.startJunc == currentJunc) && (car.endJunc == GetNextJunc(turnDirection)) &&
                        ((car.distance) < 60)) {
                    return false;
                }
            }
        }

        if (direction == DIRECTION_N) {
            if (turnDirection == DIRECTION_LEFT)
                if ((juncs[currentJunc].carsRunThrough[DIRECTION_S] != 0) ||
                        (juncs[currentJunc].carsTurnRight[DIRECTION_S] != 0))
                    return false;
        }
        if (direction == DIRECTION_E) {
            if (turnDirection == DIRECTION_LEFT)
                if ((juncs[currentJunc].carsRunThrough[DIRECTION_W] != 0) ||
                        (juncs[currentJunc].carsTurnRight[DIRECTION_W] != 0))
                    return false;
        }
        if (direction == DIRECTION_S) {
            if (turnDirection == DIRECTION_LEFT)
                if ((juncs[currentJunc].carsRunThrough[DIRECTION_N] != 0) ||
                        (juncs[currentJunc].carsTurnRight[DIRECTION_N] != 0))
                    return false;
        }
        if (direction == DIRECTION_W) {
            if (turnDirection == DIRECTION_LEFT)
                if ((juncs[currentJunc].carsRunThrough[DIRECTION_E] != 0) ||
                        (juncs[currentJunc].carsTurnRight[DIRECTION_E] != 0))
                    return false;
        }

        return true;
    }

    public synchronized void run() {
        while (!stop) {
            if (useAutoLang) {
                auto.e0();

                if (auto.getState() == AutomobileAutomataStates.s0) y0 = 0;
                if (auto.getState() == AutomobileAutomataStates.s1) y0 = 1;
                if (auto.getState() == AutomobileAutomataStates.s2) y0 = 2;
                if (auto.getState() == AutomobileAutomataStates.s3) y0 = 3;
                if (auto.getState() == AutomobileAutomataStates.s4) y0 = 4;
                if (auto.getState() == AutomobileAutomataStates.s5) y0 = 5;
                if (auto.getState() == AutomobileAutomataStates.s6) y0 = 6;
                if (auto.getState() == AutomobileAutomataStates.s7) y0 = 7;
            } else {
                autoByHand.Main(0);

                if (y0 == 0) auto.setState(AutomobileAutomataStates.s0);
                if (y0 == 1) auto.setState(AutomobileAutomataStates.s1);
                if (y0 == 2) auto.setState(AutomobileAutomataStates.s2);
                if (y0 == 3) auto.setState(AutomobileAutomataStates.s3);
                if (y0 == 4) auto.setState(AutomobileAutomataStates.s4);
                if (y0 == 5) auto.setState(AutomobileAutomataStates.s5);
                if (y0 == 6) auto.setState(AutomobileAutomataStates.s6);
                if (y0 == 7) auto.setState(AutomobileAutomataStates.s7);
            }

            try {
                Thread.sleep((long) (30));
            }
            catch (InterruptedException e) {
                System.out.println("InterruptedException in Vehicles.Automobile");
            }
        }
    }
}
