package Vehicles;

/**
 * @author Nick
 */

public class Junction implements Runnable {
    boolean useAutoLang = true;

    // 
    final static int JUNC_STATE_RED = 2;
    final static int JUNC_STATE_YELLOW_TO_RED = 1;
    final static int JUNC_STATE_YELLOW_TO_GREEN = 3;
    final static int JUNC_STATE_GREEN = 0;

    //   
    final static int JUNC_STATE_RED_NS = 2;
    final static int JUNC_STATE_YELLOW_TO_RED_NS = 1;
    final static int JUNC_STATE_YELLOW_TO_GREEN_NS = 3;
    final static int JUNC_STATE_GREEN_NS = 0;

    final static int JUNC_STATE_RED_EW = 0;
    final static int JUNC_STATE_YELLOW_TO_RED_EW = 3;
    final static int JUNC_STATE_YELLOW_TO_GREEN_EW = 1;
    final static int JUNC_STATE_GREEN_EW = 2;

    // 
    final static int EVENT_CLOCK = 0;

    //  
    final static int JUNC_TYPE_NO_TL = -1;
    final static int JUNC_TYPE_X = 0;
    final static int JUNC_TYPE_T_N = 1;
    final static int JUNC_TYPE_T_W = 2;
    final static int JUNC_TYPE_T_S = 3;
    final static int JUNC_TYPE_T_E = 4;

    int y1;

    int x, y;
    int neighbours[] = new int[4];

    int type;

    int intervalRed;
    int intervalGreen;
    int intervalYellowToRed;
    int intervalYellowToGreen;

    int carsTurnLeft[] = new int[4];
    int carsTurnRight[] = new int[4];
    int carsRunThrough[] = new int[4];


    private Thread thread;

    JunctionAutomata auto = new JunctionAutomata();
    JunctionAutomataByHand autoByHand = new JunctionAutomataByHand();

    Junction() {
        autoByHand.j = this;

        thread = new Thread(this);

        for (int i = 0; i < 4; i++) {
            carsTurnLeft[i] = 0;
            carsTurnRight[i] = 0;
            carsRunThrough[i] = 0;
        }

        auto.setState(auto.myState.s0);

        y1 = JUNC_STATE_GREEN;
    }

    void Start() {
        thread.start();
    }

    public synchronized void run() {
        while (true) {

            if (useAutoLang) {

                auto.e0();

                if (auto.getState() == auto.myState.s0) y1 = 0;
                if (auto.getState() == auto.myState.s1) y1 = 1;
                if (auto.getState() == auto.myState.s2) y1 = 2;
                if (auto.getState() == auto.myState.s3) y1 = 3;

            } else {
                autoByHand.Main(0);
            }

            try {
                if (y1 == JUNC_STATE_RED)
                    Thread.sleep(intervalRed);
                if (y1 == JUNC_STATE_GREEN)
                    Thread.sleep(intervalGreen);
                if (y1 == JUNC_STATE_YELLOW_TO_GREEN)
                    Thread.sleep(intervalYellowToGreen);
                if (y1 == JUNC_STATE_YELLOW_TO_RED)
                    Thread.sleep(intervalYellowToRed);
            }
            catch (InterruptedException e) {
            }
        }
    }
}
