package Vehicles;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * @author Nick
 */

public class MainFrame extends JApplet implements ActionListener, Runnable
{
    public World world;

    public Thread mainThread;

    public Container contentPain;

    public Container worldContainer;

    public JPanel eastPanel;
    public JPanel southPanel;


    public int cursorMode = 0;

    JRadioButton switchRadio;
    JRadioButton autoLangRadio;

    String sAdd = "    Add Car    ";
    String sRemove = "Remove Car";
    String sStart = "       Start      ";
    String sStop = "       Stop       ";

    String sAutoLang = "use automata written in automata language";
    String sSwitch = "use automata written in SWITCH technology";

    public MainFrame()
    {
        setSize(1000, 800);
        setLocation(10, 10);

        Container content = new JPanel(new BorderLayout( ));


        eastPanel = new JPanel(new BorderLayout());
        southPanel = new JPanel(new BorderLayout());

        JPanel panel1 = new JPanel(new BorderLayout());
        JPanel panel2 = new JPanel(new BorderLayout());

        JPanel panel11 = new JPanel(new FlowLayout());
        JPanel panel22 = new JPanel(new FlowLayout());
        JPanel panel33 = new JPanel(new FlowLayout());
        JPanel panel44 = new JPanel(new FlowLayout());

        JButton startButton = new JButton(sStart);
        startButton.setBounds(0,0,200,40);
        startButton.setBackground(new Color(150,180,150));
        startButton.addActionListener(this);

        JButton stopButton = new JButton(sStop);
        stopButton.setBackground(new Color(150,180,150));
        stopButton.addActionListener(this);

        JButton addCarButton = new JButton(sAdd);
        addCarButton.setBackground(new Color(150,180,150));
        addCarButton.addActionListener(this);

        JButton removeCarButton = new JButton(sRemove);
        removeCarButton.setBackground(new Color(150,180,150));
        removeCarButton.addActionListener(this);

        panel11.add(startButton);
        panel22.add(stopButton);
        panel33.add(addCarButton);
        panel44.add(removeCarButton);

        panel1.add(panel11, BorderLayout.NORTH);
        panel1.add(panel22, BorderLayout.CENTER);
        panel2.add(panel33, BorderLayout.NORTH);
        panel2.add(panel44, BorderLayout.CENTER);

        eastPanel.add(panel1, BorderLayout.NORTH);
        eastPanel.add(panel2, BorderLayout.CENTER);

        autoLangRadio = new JRadioButton(sAutoLang, true);
        switchRadio = new JRadioButton(sSwitch);

        switchRadio.addActionListener(this);
        autoLangRadio.addActionListener(this);

        southPanel.add(switchRadio, BorderLayout.NORTH);
        southPanel.add(autoLangRadio, BorderLayout.CENTER);

        content.add(eastPanel,  BorderLayout.EAST);
        content.add(southPanel,  BorderLayout.SOUTH);


        worldContainer = new JPanel(new BorderLayout());
        worldContainer.setSize(200,200);

        world = new World();

        world.Init("World.txt");

        world.setMaximumSize(new Dimension(100,100));
        world.setMinimumSize(new Dimension(100,100));
        world.setLocation(20,20);
        world.setSize(100,100);
        world.setBounds(0,0,90,90);
        world.setVisible(true);

        world.setAutoscrolls(true);

        addMouseListener(world);

        worldContainer.add(world, BorderLayout.CENTER);


        content.add(worldContainer, BorderLayout.CENTER);


        setContentPane(content);




        
        mainThread = new Thread(this);

        mainThread.start();
    }



    public static void main(String ars[])
    {
        MainFrame appwin = new MainFrame();

        appwin.setVisible(true);

        appwin.repaint();

        appwin.run();
    }


    public void paint(Graphics g)
    {
        eastPanel.repaint();
        southPanel.repaint();
        world.repaint();
    }

    public void actionPerformed(ActionEvent ae)
    {

        if (ae.getActionCommand().equals(sStart))
        {
            world.Start();

            world.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));

            world.cursorMode = 0;
        }
        if (ae.getActionCommand().equals(sStop))
        {
            world.Stop();

            world.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));

            world.cursorMode = 0;
        }

        if (ae.getActionCommand().equals(sAdd))
        {
            world.setCursor(new Cursor(Cursor.HAND_CURSOR));

            world.cursorMode = 1;
        }

        if (ae.getActionCommand().equals(sRemove))
        {
            world.setCursor(new Cursor(Cursor.HAND_CURSOR));

            world.cursorMode = 2;
        }

        if (ae.getActionCommand().equals(sSwitch))
        {
            switchRadio.setSelected(true);
            autoLangRadio.setSelected(false);

            for (Automobile car : world.automobiles)
               car.useAutoLang = false;
        }

        if (ae.getActionCommand().equals(sAutoLang))
        {
            switchRadio.setSelected(false);
            autoLangRadio.setSelected(true);

            for (Automobile car : world.automobiles)
            {
               car.useAutoLang = true;
            }
        }
    }


    public void run()
    {
        while(true)
        {
            if(world.running)
                repaint();

            try
            {
                Thread.sleep(20);
            }
            catch (InterruptedException e)
            {
                e.printStackTrace();
            }
        }
    }
}
