package Vehicles;

import Vehicles.Automobile;
import Vehicles.Junction;

import javax.swing.*;
import java.io.*;
import java.awt.*;
import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;


/**
 * @author Nick
 */
public class World extends JComponent implements MouseListener {
    Image map;

    Automobile automobiles[];
    Junction juncs[];

    Image juncBG[] = new Image[5];
    Image juncTLGreen[] = new Image[5];
    Image juncTLRed[] = new Image[5];
    Image juncTLYellow[] = new Image[5];

    Image carBMP[][][][] = new Image[2][4][3][3];

    int cursorMode = 0;

    boolean running = false;

    World()
    {
        super();

        System.out.println("Vehicles2!");

        setLocation(20,20);
        setSize(100,100);
        setBounds(0,0,90,90);

        addMouseListener(this);
    }

    void Start()
    {
        running = true;
        for (int i = 0; i < automobiles.length; i++)
           automobiles[i].Start();
    }

    void Stop()
    {
        running = false;
        for (int i = 0; i < automobiles.length; i++)
           automobiles[i].Stop();
    }

    public void paint(Graphics g)
    {
        OnDraw(g);

    }

    void OnDraw(Graphics g)
    {
        DrawMap(g);
        DrawJuncsBG(g);

        DrawCars(g);

        DrawJuncsTL(g);  
    }

    int k = 0;

    void Init(String worldName)
    {
        System.err.println("init " + worldName);

        InputStream is = getClass().getResourceAsStream(worldName);

        if(is == null)
        {
            System.out.println("can not find " + worldName);
        }

        InputStreamReader isr = new InputStreamReader(is);

        if(isr == null)
        {
            System.out.println("can not load " + worldName);
        }

        try {
            BufferedReader br = new BufferedReader(isr);

            String mapName = br.readLine();
            LoadMap(mapName);

            String juncsName = br.readLine();
            LoadJuncs(juncsName);

            LoadCars("");

            AddCars();

        } catch (IOException e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }

    }

    void LoadCars(String carName)
    {
        for (int i = 0; i < 2; i++)
        {
            carBMP[i][Automobile.DIRECTION_N][0][0] = LoadBitmapByName("Car"+(i+1)+"_sn.gif");
            carBMP[i][Automobile.DIRECTION_N][1][0] = LoadBitmapByName("Car"+(i+1)+"_sn_r.gif");
            carBMP[i][Automobile.DIRECTION_N][2][0] = LoadBitmapByName("Car"+(i+1)+"_sn_l.gif");
            carBMP[i][Automobile.DIRECTION_N][0][1] = LoadBitmapByName("Car"+(i+1)+"_sn_rr.gif");
            carBMP[i][Automobile.DIRECTION_N][0][2] = LoadBitmapByName("Car"+(i+1)+"_sn_ll.gif");
            carBMP[i][Automobile.DIRECTION_N][1][1] = LoadBitmapByName("Car"+(i+1)+"_sn_r_rr.gif");
            carBMP[i][Automobile.DIRECTION_N][2][2] = LoadBitmapByName("Car"+(i+1)+"_sn_l_ll.gif");

            carBMP[i][Automobile.DIRECTION_W][0][0] = LoadBitmapByName("Car"+(i+1)+"_ew.gif");
            carBMP[i][Automobile.DIRECTION_W][1][0] = LoadBitmapByName("Car"+(i+1)+"_ew_r.gif");
            carBMP[i][Automobile.DIRECTION_W][2][0] = LoadBitmapByName("Car"+(i+1)+"_ew_l.gif");
            carBMP[i][Automobile.DIRECTION_W][0][1] = LoadBitmapByName("Car"+(i+1)+"_ew_rr.gif");
            carBMP[i][Automobile.DIRECTION_W][0][2] = LoadBitmapByName("Car"+(i+1)+"_ew_ll.gif");
            carBMP[i][Automobile.DIRECTION_W][1][1] = LoadBitmapByName("Car"+(i+1)+"_ew_r_rr.gif");
            carBMP[i][Automobile.DIRECTION_W][2][2] = LoadBitmapByName("Car"+(i+1)+"_ew_l_ll.gif");

            carBMP[i][Automobile.DIRECTION_S][0][0] = LoadBitmapByName("Car"+(i+1)+"_ns.gif");
            carBMP[i][Automobile.DIRECTION_S][1][0] = LoadBitmapByName("Car"+(i+1)+"_ns_r.gif");
            carBMP[i][Automobile.DIRECTION_S][2][0] = LoadBitmapByName("Car"+(i+1)+"_ns_l.gif");
            carBMP[i][Automobile.DIRECTION_S][0][1] = LoadBitmapByName("Car"+(i+1)+"_ns_rr.gif");
            carBMP[i][Automobile.DIRECTION_S][0][2] = LoadBitmapByName("Car"+(i+1)+"_ns_ll.gif");
            carBMP[i][Automobile.DIRECTION_S][1][1] = LoadBitmapByName("Car"+(i+1)+"_ns_r_rr.gif");
            carBMP[i][Automobile.DIRECTION_S][2][2] = LoadBitmapByName("Car"+(i+1)+"_ns_l_ll.gif");

            carBMP[i][Automobile.DIRECTION_E][0][0] = LoadBitmapByName("Car"+(i+1)+"_we.gif");
            carBMP[i][Automobile.DIRECTION_E][1][0] = LoadBitmapByName("Car"+(i+1)+"_we_r.gif");
            carBMP[i][Automobile.DIRECTION_E][2][0] = LoadBitmapByName("Car"+(i+1)+"_we_l.gif");
            carBMP[i][Automobile.DIRECTION_E][0][1] = LoadBitmapByName("Car"+(i+1)+"_we_rr.gif");
            carBMP[i][Automobile.DIRECTION_E][0][2] = LoadBitmapByName("Car"+(i+1)+"_we_ll.gif");
            carBMP[i][Automobile.DIRECTION_E][1][1] = LoadBitmapByName("Car"+(i+1)+"_we_r_rr.gif");
            carBMP[i][Automobile.DIRECTION_E][2][2] = LoadBitmapByName("Car"+(i+1)+"_we_l_ll.gif");
        }
    }

    void AddCars()
    {
        automobiles = new Automobile[9];

        for (int i = 0; i < automobiles.length; i++)
        {
            Automobile a = new Automobile();
            a.automobileModel = i%2;
            a.velociti = 2 + i;
            a.distance = 60;
            a.startJunc = i;

            for (int k = 0; k < 4; k++)
            {
                if (juncs[i].neighbours[k] != -1)
                {
                    a.endJunc = juncs[i].neighbours[k];
                }
            }

            a.juncs = juncs;
            a.cars = automobiles;
            a.y0 = Automobile.AUTOMOBILE_STATE_RUN;

            automobiles[i] = a;
        }
    }

    void DrawCars(Graphics g)
    {
        for (Automobile car : automobiles)
        {
            int x = 0;
            int y = 0;

            if ((car.y0 == Automobile.AUTOMOBILE_STATE_RUN) ||
                    (car.y0 == Automobile.AUTOMOBILE_STATE_WAIT_CAR))
            {
                int distanceBetweenJuncs = (int) Math.sqrt(Math.pow(juncs[car.endJunc].y -
                        juncs[car.startJunc].y, 2.0) + Math.pow(juncs[car.endJunc].x -
                        juncs[car.startJunc].x, 2.0));

                x = juncs[car.startJunc].x + car.distance * (juncs[car.endJunc].x -
                        juncs[car.startJunc].x) / distanceBetweenJuncs;
                y = juncs[car.startJunc].y + car.distance * (juncs[car.endJunc].y -
                        juncs[car.startJunc].y) / distanceBetweenJuncs;

                if (car.GetDirection() == Automobile.DIRECTION_N)
                {
                    y += 5;
                    x += 5;

                    DrawBitmap(g, carBMP[car.automobileModel]
                            [car.GetDirection()][0][0], new Point(x - 16, y - 16));
                }
                if (car.GetDirection() == Automobile.DIRECTION_E)
                {
                    y += 5;
                    x -= 5;

                    DrawBitmap(g, carBMP[car.automobileModel]
                            [car.GetDirection()][0][0], new Point(x - 16, y - 16));
                }
                if (car.GetDirection() == Automobile.DIRECTION_S)
                {
                    y -= 5;
                    x -= 5;

                    DrawBitmap(g, carBMP[car.automobileModel]
                            [car.GetDirection()][0][0], new Point(x - 16, y - 16));
                }
                if (car.GetDirection() == Automobile.DIRECTION_W)
                {
                    y -= 5;
                    x += 5;

                    DrawBitmap(g, carBMP[car.automobileModel]
                            [car.GetDirection()][0][0], new Point(x - 16, y - 16));
                }
            }

            if ((car.y0 == Automobile.AUTOMOBILE_STATE_NEAR_JUNC) ||
                    (car.y0 == Automobile.AUTOMOBILE_STATE_WAIT_CAR_NEAR_JUNC) ||
                    (car.y0 == Automobile.AUTOMOBILE_STATE_WAIT_ON_JANC))
            {
                int distanceBetweenJuncs = (int) Math.sqrt(Math.pow(juncs[car.endJunc].y -
                        juncs[car.startJunc].y, 2.0) + Math.pow(juncs[car.endJunc].x -
                        juncs[car.startJunc].x, 2.0));

                x = juncs[car.startJunc].x + car.distance * (juncs[car.endJunc].x -
                        juncs[car.startJunc].x) / distanceBetweenJuncs;
                y = juncs[car.startJunc].y + car.distance * (juncs[car.endJunc].y -
                        juncs[car.startJunc].y) / distanceBetweenJuncs;

                if (car.GetDirection() == Automobile.DIRECTION_N)
                {
                    y += 5;
                    x += 5;

                    if (car.lights)
                        DrawBitmap(g, carBMP[car.automobileModel]
                                [car.GetDirection()][0][car.turnDirection],
                                new Point(x - 16, y - 16));
                    else
                        DrawBitmap(g, carBMP[car.automobileModel]
                                [car.GetDirection()][0][0], new Point(x - 16, y - 16));
                }
                if (car.GetDirection() == Automobile.DIRECTION_E)
                {
                    y += 5;
                    x -= 5;

                    if (car.lights)
                        DrawBitmap(g, carBMP[car.automobileModel]
                                [car.GetDirection()][0][car.turnDirection],
                                new Point(x - 16, y - 16));
                    else
                        DrawBitmap(g, carBMP[car.automobileModel]
                                [car.GetDirection()][0][0], new Point(x - 16, y - 16));
                }
                if (car.GetDirection() == Automobile.DIRECTION_S)
                {
                    y -= 5;
                    x -= 5;

                    if (car.lights)
                        DrawBitmap(g, carBMP[car.automobileModel]
                                [car.GetDirection()][0][car.turnDirection],
                                new Point(x - 16, y - 16));
                    else
                        DrawBitmap(g, carBMP[car.automobileModel]
                                [car.GetDirection()][0][0], new Point(x - 16, y - 16));
                }
                if (car.GetDirection() == Automobile.DIRECTION_W)
                {
                    y -= 5;
                    x += 5;

                    if (car.lights)
                        DrawBitmap(g, carBMP[car.automobileModel]
                                [car.GetDirection()][0][car.turnDirection],
                                new Point(x - 16, y - 16));
                    else
                        DrawBitmap(g, carBMP[car.automobileModel]
                                [car.GetDirection()][0][0], new Point(x - 16, y - 16));
                }
            }

            int direction = car.GetDirection();
            int td = car.turnDirection;
            int oldDirection = Automobile.DIRECTION_N;

            if (direction == Automobile.DIRECTION_N)
            {
                if (td == Automobile.DIRECTION_THROUGH)
                    oldDirection = Automobile.DIRECTION_N;
                if (td == Automobile.DIRECTION_RIGHT)
                    oldDirection = Automobile.DIRECTION_W;
                if (td == Automobile.DIRECTION_LEFT)
                    oldDirection = Automobile.DIRECTION_E;
            }
            if (direction == Automobile.DIRECTION_E)
            {
                if (td == Automobile.DIRECTION_THROUGH)
                    oldDirection = Automobile.DIRECTION_E;
                if (td == Automobile.DIRECTION_RIGHT)
                    oldDirection = Automobile.DIRECTION_N;
                if (td == Automobile.DIRECTION_LEFT)
                    oldDirection = Automobile.DIRECTION_S;
            }
            if (direction == Automobile.DIRECTION_S)
            {
                if (td == Automobile.DIRECTION_THROUGH)
                    oldDirection = Automobile.DIRECTION_S;
                if (td == Automobile.DIRECTION_RIGHT)
                    oldDirection = Automobile.DIRECTION_E;
                if (td == Automobile.DIRECTION_LEFT)
                    oldDirection = Automobile.DIRECTION_W;
            }
            if (direction == Automobile.DIRECTION_W)
            {
                if (td == Automobile.DIRECTION_THROUGH)
                    oldDirection = Automobile.DIRECTION_W;
                if (td == Automobile.DIRECTION_RIGHT)
                    oldDirection = Automobile.DIRECTION_S;
                if (td == Automobile.DIRECTION_LEFT)
                    oldDirection = Automobile.DIRECTION_N;
            }


            if (car.y0 == Automobile.AUTOMOBILE_STATE_TURN_THROUGH)
            {
/*                int distanceBetweenJuncs = (int) Math.sqrt(Math.pow(juncs[car.endJunc].y -
                        juncs[car.startJunc].y, 2.0) + Math.pow(juncs[car.endJunc].x -
                        juncs[car.startJunc].x, 2.0));
  */
                x = juncs[car.startJunc].x;
                y = juncs[car.startJunc].y;

                double dim = 8.0 / 10.0;

                if (oldDirection == Automobile.DIRECTION_N)
                {
                    y += 5;
                    x += 5;

                    y += 20;
                    x -= 12;

                    y -= 5 * car.turnPosition * dim;
                    x += 3 * car.turnPosition * dim;

                    DrawBitmap(g, carBMP[car.automobileModel]
                            [car.GetDirection()][0][0], new Point(x - 16, y - 16));
                }
                if (oldDirection == Automobile.DIRECTION_E)
                {
                    y += 5;
                    x -= 5;

                    y -= 6;
                    x -= 20;

                    y += 1.5 * car.turnPosition * dim;
                    x += 5 * car.turnPosition * dim;

                    DrawBitmap(g, carBMP[car.automobileModel]
                            [car.GetDirection()][0][0], new Point(x - 16, y - 16));
                }
                if (oldDirection == Automobile.DIRECTION_S)
                {
                    y -= 5;
                    x -= 5;

                    y -= 20;
                    x += 12;

                    y += 5 * car.turnPosition * dim;
                    x -= 3 * car.turnPosition * dim;

                    DrawBitmap(g, carBMP[car.automobileModel]
                            [car.GetDirection()][0][0], new Point(x - 16, y - 16));
                }
                if (oldDirection == Automobile.DIRECTION_W)
                {
                    y -= 5;
                    x += 5;

                    y += 6;
                    x += 20;

                    y -= 1.5 * car.turnPosition * dim;
                    x -= 5 * car.turnPosition * dim;

                    DrawBitmap(g, carBMP[car.automobileModel]
                            [car.GetDirection()][0][0], new Point(x - 16, y - 16));
                }
            }

            if (car.y0 == Automobile.AUTOMOBILE_STATE_TURN_RIGHT)
            {
/*                int distanceBetweenJuncs = (int) Math.sqrt(Math.pow(juncs[car.endJunc].y -
                        juncs[car.startJunc].y, 2.0) + Math.pow(juncs[car.endJunc].x -
                        juncs[car.startJunc].x, 2.0));
  */
                x = juncs[car.startJunc].x;
                y = juncs[car.startJunc].y;

                double dim = 8.0 / 10.0;

                if (car.turnPosition < 2)
                {

                    if (oldDirection == Automobile.DIRECTION_N)
                    {
                        y += 5;
                        x += 5;

                        y += 20;
                        x -= 12;

                        y -= 5 * car.turnPosition * dim;
                        x += 3 * car.turnPosition * dim;

                        if (car.lights)
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [oldDirection][0][car.turnDirection],
                                    new Point(x - 16, y - 16));
                        else
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [oldDirection][0][0], new Point(x - 16, y - 16));
                    }
                    if (oldDirection == Automobile.DIRECTION_E)
                    {
                        y += 5;
                        x -= 5;

                        y -= 6;
                        x -= 20;

                        y += 1.5 * car.turnPosition * dim;
                        x += 5 * car.turnPosition * dim;

                        if (car.lights)
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [oldDirection][0][car.turnDirection],
                                    new Point(x - 16, y - 16));
                        else
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [oldDirection][0][0], new Point(x - 16, y - 16));
                    }
                    if (oldDirection == Automobile.DIRECTION_S)
                    {
                        y -= 5;
                        x -= 5;

                        y -= 20;
                        x += 12;

                        y += 5 * car.turnPosition * dim;
                        x -= 3 * car.turnPosition * dim;

                        if (car.lights)
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [oldDirection][0][car.turnDirection],
                                    new Point(x - 16, y - 16));
                        else
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [oldDirection][0][0], new Point(x - 16, y - 16));
                    }
                    if (oldDirection == Automobile.DIRECTION_W)
                    {
                        y -= 5;
                        x += 5;

                        y += 6;
                        x += 20;

                        y -= 1.5 * car.turnPosition * dim;
                        x -= 5 * car.turnPosition * dim;

                        if (car.lights)
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [oldDirection][0][car.turnDirection],
                                    new Point(x - 16, y - 16));
                        else
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [oldDirection][0][0], new Point(x - 16, y - 16));
                    }
                }

                if ((car.turnPosition >= 2) && (car.turnPosition <= 4))
                {
                    if (oldDirection == Automobile.DIRECTION_N)
                    {
                        y += 5;
                        x += 5;

                        y += 20;
                        x -= 12;

                        y -= 5 * 2 * dim;
                        x += 3 * 2 * dim;

                        y -= 3 * (car.turnPosition - 2) * dim;
                        x += 5 * (car.turnPosition - 2) * dim;

                        if (car.lights)
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [oldDirection][1][car.turnDirection],
                                    new Point(x - 16, y - 16));
                        else
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [oldDirection][1][0], new Point(x - 16, y - 16));
                    }
                    if (oldDirection == Automobile.DIRECTION_E)
                    {
                        y += 5;
                        x -= 5;

                        y -= 6;
                        x -= 20;

                        y += 1.5 * 2 * dim;
                        x += 5 * 2 * dim;

                        y += 5 * (car.turnPosition - 2) * dim;
                        x += 1.5 * (car.turnPosition - 2) * dim;

                        if (car.lights)
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [oldDirection][1][car.turnDirection],
                                    new Point(x - 16, y - 16));
                        else
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [oldDirection][1][0], new Point(x - 16, y - 16));
                    }
                    if (oldDirection == Automobile.DIRECTION_S)
                    {
                        y -= 5;
                        x -= 5;

                        y -= 20;
                        x += 12;

                        y += 5 * 2 * dim;
                        x -= 3 * 2 * dim;

                        y += 3 * (car.turnPosition - 2) * dim;
                        x -= 5 * (car.turnPosition - 2) * dim;

                        if (car.lights)
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [oldDirection][1][car.turnDirection],
                                    new Point(x - 16, y - 16));
                        else
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [oldDirection][1][0], new Point(x - 16, y - 16));
                    }
                    if (oldDirection == Automobile.DIRECTION_W)
                    {
                        y -= 5;
                        x += 5;

                        y += 6;
                        x += 20;

                        y -= 1.5 * 2 * dim;
                        x -= 5 * 2 * dim;

                        y -= 5 * (car.turnPosition - 2) * dim;
                        x += 1.5 * (car.turnPosition - 2) * dim;

                        if (car.lights)
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [oldDirection][1][car.turnDirection],
                                    new Point(x - 16, y - 16));
                        else
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [oldDirection][1][0], new Point(x - 16, y - 16));
                    }
                }

                if (car.turnPosition > 4)
                {
                    if (direction == Automobile.DIRECTION_N)
                    {
                        y += 5;
                        x += 5;

                        y += 20;
                        x -= 12;

                        y -= 5 * (car.turnPosition + 4) * dim;
                        x += 3 * (car.turnPosition + 4) * dim;

                        if (car.lights)
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [car.GetDirection()][0][car.turnDirection],
                                    new Point(x - 16, y - 16));
                        else
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [car.GetDirection()][0][0], new Point(x - 16, y - 16));
                    }
                    if (direction == Automobile.DIRECTION_E)
                    {
                        y += 5;
                        x -= 5;

                        y -= 6;
                        x -= 20;

                        y += 1.5 * (car.turnPosition + 4) * dim;
                        x += 5 * (car.turnPosition + 4) * dim;

                        if (car.lights)
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [car.GetDirection()][0][car.turnDirection],
                                    new Point(x - 16, y - 16));
                        else
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [car.GetDirection()][0][0], new Point(x - 16, y - 16));
                    }
                    if (direction == Automobile.DIRECTION_S)
                    {
                        y -= 5;
                        x -= 5;

                        y -= 20;
                        x += 12;

                        y += 5 * (car.turnPosition + 4) * dim;
                        x -= 3 * (car.turnPosition + 4) * dim;

                        if (car.lights)
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [car.GetDirection()][0][car.turnDirection],
                                    new Point(x - 16, y - 16));
                        else
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [car.GetDirection()][0][0], new Point(x - 16, y - 16));
                    }
                    if (direction == Automobile.DIRECTION_W)
                    {
                        y -= 5;
                        x += 5;

                        y += 6;
                        x += 20;

                        y -= 1.5 * (car.turnPosition + 4) * dim;
                        x -= 5 * (car.turnPosition + 4) * dim;

                        if (car.lights)
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [car.GetDirection()][0][car.turnDirection],
                                    new Point(x - 16, y - 16));
                        else
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [car.GetDirection()][0][0], new Point(x - 16, y - 16));
                    }
                }
            }

            if (car.y0 == Automobile.AUTOMOBILE_STATE_TURN_LEFT)
            {
/*
                int distanceBetweenJuncs = (int) Math.sqrt(Math.pow(juncs[car.endJunc].y -
                        juncs[car.startJunc].y, 2.0) + Math.pow(juncs[car.endJunc].x -
                        juncs[car.startJunc].x, 2.0));
*/

                x = juncs[car.startJunc].x;
                y = juncs[car.startJunc].y;

                double dim = 8.0 / 10.0;

                if (car.turnPosition < 2)
                {

                    if (oldDirection == Automobile.DIRECTION_N)
                    {
                        y += 5;
                        x += 5;

                        y += 20;
                        x -= 12;

                        y -= 5 * car.turnPosition * dim;
                        x += 3 * car.turnPosition * dim;

                        if (car.lights)
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [oldDirection][0][car.turnDirection],
                                    new Point(x - 16, y - 16));
                        else
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [oldDirection][0][0], new Point(x - 16, y - 16));
                    }
                    if (oldDirection == Automobile.DIRECTION_E)
                    {
                        y += 5;
                        x -= 5;

                        y -= 6;
                        x -= 20;

                        y += 1.5 * car.turnPosition * dim;
                        x += 5 * car.turnPosition * dim;

                        if (car.lights)
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [oldDirection][0][car.turnDirection],
                                    new Point(x - 16, y - 16));
                        else
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [oldDirection][0][0], new Point(x - 16, y - 16));
                    }
                    if (oldDirection == Automobile.DIRECTION_S)
                    {
                        y -= 5;
                        x -= 5;

                        y -= 20;
                        x += 12;

                        y += 5 * car.turnPosition * dim;
                        x -= 3 * car.turnPosition * dim;

                        if (car.lights)
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [oldDirection][0][car.turnDirection],
                                    new Point(x - 16, y - 16));
                        else
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [oldDirection][0][0], new Point(x - 16, y - 16));
                    }
                    if (oldDirection == Automobile.DIRECTION_W)
                    {
                        y -= 5;
                        x += 5;

                        y += 6;
                        x += 20;

                        y -= 1.5 * car.turnPosition * dim;
                        x -= 5 * car.turnPosition * dim;

                        if (car.lights)
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [oldDirection][0][car.turnDirection],
                                    new Point(x - 16, y - 16));
                        else
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [oldDirection][0][0], new Point(x - 16, y - 16));
                    }

                    //g.Ellipse(x-2,y-2,x+2,y+2);

                }

                if ((car.turnPosition >= 2) && (car.turnPosition <= 8))
                {
                    if (oldDirection == Automobile.DIRECTION_N)
                    {
                        y += 5;
                        x += 5;

                        y += 20;
                        x -= 12;

                        y -= 5 * 2 * dim;
                        x += 3 * 2 * dim;

                        y -= 5 * (car.turnPosition - 2) * dim;
                        x -= 3 * (car.turnPosition - 2) * dim;

                        if (car.lights)
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [oldDirection][2][car.turnDirection],
                                    new Point(x - 16, y - 16));
                        else
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [oldDirection][2][0], new Point(x - 16, y - 16));
                    }
                    if (oldDirection == Automobile.DIRECTION_E)
                    {
                        y += 5;
                        x -= 5;

                        y -= 6;
                        x -= 20;

                        y += 1.5 * 2 * dim;
                        x += 5 * 2 * dim;

                        y -= 1.5 * (car.turnPosition - 2) * dim;
                        x += 5 * (car.turnPosition - 2) * dim;

                        if (car.lights)
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [oldDirection][2][car.turnDirection],
                                    new Point(x - 16, y - 16));
                        else
                            DrawBitmap(g, carBMP[car.automobileModel]
                                    [oldDirection][2][0], new Point(x - 16, y - 16));
                    }
                    if (oldDirection == Automobile.DIRECTION_S)
                    {
                        y -= 5;
                        x -= 5;

                        y -= 20;
                        x += 12;

                        y += 5 * 2 * dim;
                        x -= 3 * 2 * dim;

                        y += 5 * (car.turnPosition - 2) * dim;
                        x += 3 * (car.turnPosition - 2) * dim;

                        if (car.lights)
                            DrawBitmap(g,
                                    carBMP[car.automobileModel]
                                            [oldDirection][2][car.turnDirection],
                                    new Point(x - 16, y - 16));
                        else
                            DrawBitmap(g,
                                    carBMP[car.automobileModel]
                                            [oldDirection][2][0], new Point(x - 16, y - 16));
                    }
                    if (oldDirection == Automobile.DIRECTION_W)
                    {
                        y -= 5;
                        x += 5;

                        y += 6;
                        x += 20;

                        y -= 1.5 * 2 * dim;
                        x -= 5 * 2 * dim;

                        y += 1.5 * (car.turnPosition - 2) * dim;
                        x -= 5 * (car.turnPosition - 2) * dim;

                        if (car.lights)
                            DrawBitmap(g,
                                    carBMP[car.automobileModel]
                                            [oldDirection][2][car.turnDirection],
                                    new Point(x - 16, y - 16));
                        else
                            DrawBitmap(g,
                                    carBMP[car.automobileModel]
                                            [oldDirection][2][0], new Point(x - 16, y - 16));
                    }
                }

                if (car.turnPosition > 8)
                {
                    if (direction == Automobile.DIRECTION_N)
                    {
                        y += 5;
                        x += 5;

                        y += 20;
                        x -= 12;

                        y -= 5 * (car.turnPosition) * dim;
                        x += 3 * (car.turnPosition) * dim;

                        if (car.lights)
                            DrawBitmap(g,
                                    carBMP[car.automobileModel]
                                            [car.GetDirection()][0][car.turnDirection],
                                    new Point(x - 16, y - 16));
                        else
                            DrawBitmap(g,
                                    carBMP[car.automobileModel]
                                            [car.GetDirection()][0][0],
                                    new Point(x - 16, y - 16));
                    }
                    if (direction == Automobile.DIRECTION_E)
                    {
                        y += 5;
                        x -= 5;

                        y -= 6;
                        x -= 20;

                        y += 1.5 * (car.turnPosition) * dim;
                        x += 5 * (car.turnPosition) * dim;

                        if (car.lights)
                            DrawBitmap(g,
                                    carBMP[car.automobileModel]
                                            [car.GetDirection()][0][car.turnDirection],
                                    new Point(x - 16, y - 16));
                        else
                            DrawBitmap(g,
                                    carBMP[car.automobileModel]
                                            [car.GetDirection()][0][0],
                                    new Point(x - 16, y - 16));
                    }
                    if (direction == Automobile.DIRECTION_S)
                    {
                        y -= 5;
                        x -= 5;

                        y -= 20;
                        x += 12;

                        y += 5 * (car.turnPosition) * dim;
                        x -= 3 * (car.turnPosition) * dim;

                        if (car.lights)
                            DrawBitmap(g,
                                    carBMP[car.automobileModel]
                                            [car.GetDirection()][0][car.turnDirection],
                                    new Point(x - 16, y - 16));
                        else
                            DrawBitmap(g,
                                    carBMP[car.automobileModel]
                                            [car.GetDirection()][0][0],
                                    new Point(x - 16, y - 16));
                    }
                    if (direction == Automobile.DIRECTION_W)
                    {
                        y -= 5;
                        x += 5;

                        y += 6;
                        x += 20;

                        y -= 1.5 * (car.turnPosition) * dim;
                        x -= 5 * (car.turnPosition) * dim;

                        if (car.lights)
                            DrawBitmap(g,
                                    carBMP[car.automobileModel]
                                            [car.GetDirection()][0][car.turnDirection],
                                    new Point(x - 16, y - 16));
                        else
                            DrawBitmap(g,
                                    carBMP[car.automobileModel]
                                            [car.GetDirection()][0][0], new Point(x - 16, y - 16));
                    }

                    //g.Ellipse(x-2,y-2,x+2,y+2);

                }

            }

            car.point.x = x;
            car.point.y = y;

            //g.Ellipse(x-2,y-2,x+2,y+2);
        }
    }


    void LoadMap(String mapName)
    {
        map = LoadBitmapByName(mapName);
    }

    void DrawMap(Graphics g)
    {
        DrawBitmap(g, map, new Point(0, 0));
    }

    int atoi(char[] b, int pos)
    {
        int res = 0;
        while((pos != b.length) && (b[pos] != ' ') && (b[pos] != 0))
        {
            res = res*10 + (b[pos] - '0');
            pos++;
        }
        return res;
    }

    void LoadJuncs(String juncsName)
    {
        juncBG[Junction.JUNC_TYPE_X] = LoadBitmapByName("Junc_X_bg.gif");
        juncTLRed[Junction.JUNC_TYPE_X] = LoadBitmapByName("Junc_X_tl_r.gif");
        juncTLGreen[Junction.JUNC_TYPE_X] = LoadBitmapByName("Junc_X_tl_g.gif");
        juncTLYellow[Junction.JUNC_TYPE_X] = LoadBitmapByName("Junc_X_tl_y.gif");

        juncBG[Junction.JUNC_TYPE_T_S] = LoadBitmapByName("Junc_T_s_bg.gif");
        juncTLRed[Junction.JUNC_TYPE_T_S] = LoadBitmapByName("Junc_T_s_tl_r.gif");
        juncTLGreen[Junction.JUNC_TYPE_T_S] = LoadBitmapByName("Junc_T_s_tl_g.gif");
        juncTLYellow[Junction.JUNC_TYPE_T_S] = LoadBitmapByName("Junc_T_s_tl_y.gif");

        juncBG[Junction.JUNC_TYPE_T_W] = LoadBitmapByName("Junc_T_w_bg.gif");
        juncTLRed[Junction.JUNC_TYPE_T_W] = LoadBitmapByName("Junc_T_w_tl_r.gif");
        juncTLGreen[Junction.JUNC_TYPE_T_W] = LoadBitmapByName("Junc_T_w_tl_g.gif");
        juncTLYellow[Junction.JUNC_TYPE_T_W] = LoadBitmapByName("Junc_T_w_tl_y.gif");


        //File file = new File(juncsName);

        InputStream is = World.class.getResourceAsStream(juncsName);
        InputStreamReader isr = new InputStreamReader(is);

        try {
            BufferedReader br = new BufferedReader(isr);


//        try
  //      {
    //        FileReader fi1eReader = new FileReader(file);
      //      BufferedReader br = new BufferedReader(fi1eReader);

            String s;
            s = br.readLine();
            StringBuffer data = new StringBuffer(s);
            char p[] = new char[data.length()];
            data.getChars(0, data.length(), p, 0);
            int juncsNumber = atoi(p, 0);

            juncs = new Junction[juncsNumber];

            for (int i = 0; i < juncsNumber; i++)
            {
                s = br.readLine();
                data = new StringBuffer(s);

                p = new char[data.length()];
                data.getChars(0, data.length(), p, 0);
                Junction junc = new Junction();

                int j = 0;
                while (p[j] != ' ')
                {
                    j++;
                }
                j++;

                junc.x = atoi(p, j);
                while (p[j] != ' ')
                {
                    j++;
                }
                j++;
                junc.y = atoi(p, j);

                int n = 4;

                for (int k = 0; k < n; k++)
                {
                    while (p[j] != ' ')
                    {
                        j++;
                    }
                    j++;

                    if (p[j] != '#')
                    {
                        junc.neighbours[k] = atoi(p, j);
                    }
                    else
                    {
                        junc.neighbours[k] = -1;
                    }
                }

                if ((junc.neighbours[0] != -1) &&
                        (junc.neighbours[1] != -1) &&
                        (junc.neighbours[2] != -1) &&
                        (junc.neighbours[3] != -1))
                {
                    junc.type = Junction.JUNC_TYPE_X;
                }
                else if ((junc.neighbours[0] == -1) &&
                        (junc.neighbours[1] != -1) &&
                        (junc.neighbours[2] != -1) &&
                        (junc.neighbours[3] != -1))
                {
                    junc.type = Junction.JUNC_TYPE_T_S;
                }
                else if ((junc.neighbours[0] != -1) &&
                        (junc.neighbours[1] != -1) &&
                        (junc.neighbours[2] == -1) &&
                        (junc.neighbours[3] != -1))
                {
                    junc.type = Junction.JUNC_TYPE_T_N;
                }
                else if ((junc.neighbours[0] != -1) &&
                        (junc.neighbours[1] == -1) &&
                        (junc.neighbours[2] != -1) &&
                        (junc.neighbours[3] != -1))
                {
                    junc.type = Junction.JUNC_TYPE_T_E;
                }
                else if ((junc.neighbours[0] != -1) &&
                        (junc.neighbours[1] != -1) &&
                        (junc.neighbours[2] != -1) &&
                        (junc.neighbours[3] == -1))
                {
                    junc.type = Junction.JUNC_TYPE_T_W;
                }
                else
                {
                    junc.type = Junction.JUNC_TYPE_NO_TL;
                }

                junc.intervalGreen = 1000*(i+1);
                junc.intervalRed = 1000*(i+1);
                junc.intervalYellowToGreen = 100*(i+1);
                junc.intervalYellowToRed = 100*(i+1);

                junc.Start();

                juncs[i] = junc;
            }


        }
        catch (FileNotFoundException ex)
        {
            ex.printStackTrace();

        }
        catch (IOException ex)
        {
            ex.printStackTrace();
        }
    }

    void DrawJuncsBG(Graphics g)
    {
        for (Junction junc : juncs)
        {
            if (junc.type == Junction.JUNC_TYPE_X)
            {
                DrawBitmap(g, juncBG[junc.type],
                        new Point(junc.x - 60, junc.y - 55));
            }
            if (junc.type == Junction.JUNC_TYPE_T_S)
            {
                DrawBitmap(g, juncBG[junc.type],
                        new Point(junc.x - 62, junc.y - 46));
            }
            if (junc.type == Junction.JUNC_TYPE_T_W)
            {
                DrawBitmap(g, juncBG[junc.type],
                        new Point(junc.x - 56, junc.y - 55));
            }
        }
    }

    void DrawJuncsTL(Graphics g)
    {
        for (Junction junc : juncs)
        {
            if (junc.type != Junction.JUNC_TYPE_NO_TL)
            {
                if (junc.y1 == Junction.JUNC_STATE_GREEN)
                    DrawBitmap(g, juncTLGreen[junc.type],
                            new Point(junc.x - 39, junc.y - 58));

                if (junc.y1 == Junction.JUNC_STATE_RED)
                    DrawBitmap(g, juncTLRed[junc.type],
                            new Point(junc.x - 39, junc.y - 58));

                if ((junc.y1 == Junction.JUNC_STATE_YELLOW_TO_GREEN) ||
                        (junc.y1 == Junction.JUNC_STATE_YELLOW_TO_RED))
                    DrawBitmap(g, juncTLYellow[junc.type],
                            new Point(junc.x - 39, junc.y - 58));
            }
        }
    }

    Image LoadBitmapByName(String fileName)
    {

        java.net.URL imgURL;

        imgURL = getClass().getResource("images/" + fileName);

        if(imgURL != null)
        {
            Image i = getToolkit().getImage(imgURL);


            prepareImage(i, this);

            System.out.println(fileName + " loaded");

            return i;
        }
        else
        {
            System.out.println("cannot find " + fileName);

            return null;
        }
    }

    void DrawBitmap(Graphics g, Image i, Point point)
    {
        //System.out.println((int)getX() + " " + (int)getY());

        g.drawImage(i, getX() + (int)point.getX(), getY() + (int)point.getY(), this);
    }


    public void mouseClicked(MouseEvent e) {


 
        Point point = e.getPoint();
        //point.x += GetScrollPos(0);
        //point.y += GetScrollPos(1);


        if (cursorMode == 2) {
            int size = automobiles.length;
            for (int i = 0; i < size; i++) {
                Point carPoint = automobiles[i].point;
                if ((Math.sqrt((double) (carPoint.x - point.x) * (carPoint.x - point.x) + (carPoint.y - point.y) * (carPoint.y - point.y)) < 25)) {

                    automobiles[i].Stop();
                    if(automobiles[i].y0 != Automobile.AUTOMOBILE_STATE_RUN &&
                            automobiles[i].y0 != Automobile.AUTOMOBILE_STATE_WAIT_CAR)
                    {
                        automobiles[i].z6();                        
                    }

                    Automobile newcars[] = new Automobile[automobiles.length - 1];

                    int k = 0;
                    for (int j = 0; j < size; j++) {
                        if (i != j) {
                            newcars[k] = automobiles[j];
                            k++;
                        }
                    }

                    automobiles = newcars;

                    for (int j = 0; j < automobiles.length; j++) {
                        automobiles[j].cars = automobiles;
                    }

                    setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
                    cursorMode = 0;
                    
                    repaint();

                    return;
                }
            }
        }

        if (cursorMode == 1) {
            int size = juncs.length;
            for (int i = 0; i < size; i++) {
                Point jancPoint = new Point();
                jancPoint.x = juncs[i].x;
                jancPoint.y = juncs[i].y;
                if (Math.sqrt((double) (jancPoint.x - point.x) * (jancPoint.x - point.x) + (jancPoint.y - point.y) * (jancPoint.y - point.y)) < 25) {
                    Automobile a = new Automobile();
                    a.automobileModel = (int) (Math.random() + 0.5);
                    a.velociti = 2 + (int)(Math.random() * 6);
                    a.distance = 60;
                    a.startJunc = i;

                    for (int k = 0; k < 4; k++) {
                        if (juncs[i].neighbours[k] != -1) {
                            a.endJunc = juncs[i].neighbours[k];
                        }
                    }

                    a.juncs = juncs;
                    a.cars = automobiles;
                    a.y0 = Automobile.AUTOMOBILE_STATE_RUN;

                    Automobile newcars[] = new Automobile[automobiles.length + 1];

                    for (int j = 0; j < automobiles.length; j++) {
                        newcars[j] = automobiles[j];
                    }

                    if(running)
                        a.Start();

                    newcars[automobiles.length] = a;

                    automobiles = newcars;

                    for (int j = 0; j < automobiles.length; j++) {
                        automobiles[j].cars = automobiles;
                    }

                    setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
                    cursorMode = 0;

                    repaint();

                    return;
                }
            }
        }

    }

    public void mousePressed(MouseEvent e) {
    }

    public void mouseReleased(MouseEvent e) {
    }

    public void mouseEntered(MouseEvent e) {
    }

    public void mouseExited(MouseEvent e) {
    }
}
